'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _loreHookConnect = require('lore-hook-connect');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _loreHookConnect.connect)(function () {
  return {};
}, { subscribe: true })((0, _createReactClass2.default)({
  displayName: 'Dialog',

  propTypes: {
    dialog: _propTypes2.default.node.isRequired
  },

  /**
   * Have the dialog open after we mount the component to make sure
   * we see the opening transition - if we don't do this, it will
   * immediately snap into view on the screen (without a gentle transition)
   */
  componentDidMount: function componentDidMount() {
    this.show();
  },

  show: function show() {
    var modal = this.refs.modal;
    $(modal).modal('show');
  },

  dismiss: function dismiss() {
    var modal = this.refs.modal;
    $(modal).modal('hide');
  },

  render: function render() {
    var dialog = this.props.dialog;


    return _react2.default.createElement(
      'div',
      { ref: 'modal', className: 'modal fade' },
      _react2.default.cloneElement(dialog, {
        onCancel: this.dismiss
      })
    );
  }
}));