'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {

  defaults: {
    dialog: _config2.default
  },

  load: function load(lore) {
    var _lore$config$dialog = lore.config.dialog,
        domElementId = _lore$config$dialog.domElementId,
        buildDialogContainer = _lore$config$dialog.buildDialogContainer,
        renderDialogToDom = _lore$config$dialog.renderDialogToDom;


    lore.dialog = {};

    lore.dialog.show = function (component) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var dialog = _lodash2.default.isFunction(component) ? component() : component;

      if (!dialog) {
        throw new Error('Must provide a component to lore.dialog.show');
      }

      var DialogContainer = buildDialogContainer(lore, options);

      // Find the proper DOM element and mount the dialog to it
      renderDialogToDom(options.domElementId || domElementId, _react2.default.createElement(DialogContainer, { dialog: dialog }));
    };
  }

}; /* eslint no-param-reassign: "off" */

module.exports = exports['default'];